#include "DFITCL2Api.h"
#include "my_callback.h"
#include <iostream>
#include <stdio.h>
#include <stdlib.h>

using namespace DFITC_L2;

extern DFITC_L2::DFITCL2Api * g_pApi;
extern FILE    *g_quote_fp;

extern void recBestAndDeep(MDBestAndDeep *const pBDQuote, FILE	*fp);
extern void recTenEntrust(MDTenEntrust * const p_quote, FILE *fp);
extern void recRealtime(MDRealTimePrice * const p_quote, FILE *fp);
extern void recOrderStatistic(MDOrderStatistic * const p_quote, FILE *fp);
extern void recMarchPrice(MDMarchPriceQty * const p_quote, FILE *fp);
extern void recArbi(MDBestAndDeep * const pQuote, FILE *fp);


UINT4 BDSequenceNo=-1;
UINT4 ArbiSequenceNo = -1;
UINT4 TenSequenceNo = -1;
UINT4 RealtimeSequenceNo = -1;
UINT4 StatisticsSequenceNo = -1;
UINT4 MarchSequenceNo = -1;

void my_callback_t::OnConnected() { 
    std::cout << "my_callback_t::OnConnected" << std::endl; 
}


void my_callback_t::OnDisconnected(int pReason) { 
    std::cout << "my_callback_t::OnDisconnected" << std::endl; 
}


void my_callback_t::OnRspUserLogin(struct ErrorRtnField * pErrorField)  { 

    std::cout << "my_callback_t::OnRspUserLogin" << std::endl; 
    int ret = g_pApi->SubscribeAll();
    std::cout << "call SubscribeAll  return = "<< ret << std::endl;

}


void my_callback_t::OnRspUserLogout(struct ErrorRtnField * pErrorField) {
    std::cout << "my_callback_t::OnRspUserLogout" << std::endl;
}


void my_callback_t::OnRspSubscribeMarketData(struct ErrorRtnField * pErrorField) { 
    std::cout << "my_callback_t::OnRspSubscribeMarketData" << std::endl;
}


void my_callback_t::OnRspUnSubscribeMarketData(ErrorRtnField * pErrorField) { 
    std::cout << "my_callback_t::OnRspUnSubscribeMarketData" << std::endl; 
}


void my_callback_t::OnRspSubscribeAll(struct ErrorRtnField * pErrorField) { 
    std::cout << "my_callback_t::OnRspSubscribeAll" << std::endl;
}


void my_callback_t::OnRspUnSubscribeAll(struct ErrorRtnField * pErrorField) { 
    std::cout << "my_callback_t::OnRspUnSubscribeAll" << std::endl;
}


void my_callback_t::OnRspModifyPassword(struct ErrorRtnField * pErrorField) { 
    std::cout << "my_callback_t::OnRspModifyPassword" << std::endl; 
}


void my_callback_t::OnHeartBeatLost() { 
    std::cout << "my_callback_t::OnHeartBeatLost" << std::endl; 
}

void my_callback_t::OnBestAndDeep(MDBestAndDeep * const pQuote, UINT4 SequenceNo)  {

    if( abs(SequenceNo - BDSequenceNo != 1) && BDSequenceNo!=-1){
        printf("Sequence break . %d\n", SequenceNo);
    }
    BDSequenceNo = SequenceNo;

//    std::cout << "my_callback_t::OnBestAndDeep, seqNo = " << SequenceNo << std::endl;
    recBestAndDeep(pQuote, g_quote_fp);
}

void my_callback_t::OnArbi(MDBestAndDeep * const pQuote, UINT4 SequenceNo){
    if (abs(SequenceNo - ArbiSequenceNo != 1) && ArbiSequenceNo != -1) {
        printf("Arbi Sequence break . %d\n", SequenceNo);
    }
    ArbiSequenceNo = SequenceNo;

//    std::cout << "my_callback_t::OnArbi, seqNo = " << SequenceNo << std::endl;
    recArbi(pQuote, g_quote_fp);
}

void my_callback_t::OnTenEntrust(MDTenEntrust * const pQuote, UINT4 SequenceNo)  {

    if (abs(SequenceNo - TenSequenceNo != 1) && TenSequenceNo != -1) {
        printf("TEN Sequence break . %d\n", SequenceNo);
    }
    TenSequenceNo = SequenceNo;

//    std::cout << "my_callback_t::OnTenEntrust, seqNo = " << SequenceNo << std::endl;
    recTenEntrust(pQuote, g_quote_fp);
}

void my_callback_t::OnRealtime(MDRealTimePrice * const pQuote, UINT4 SequenceNo) {

    UINT4 RealtimeSequenceNo = -1;
    if (abs(SequenceNo - RealtimeSequenceNo != 1) && RealtimeSequenceNo != -1) {
        printf("RealTime Sequence break . %d\n", SequenceNo);
    }
    RealtimeSequenceNo = SequenceNo;

//    std::cout << "my_callback_t::OnRealtime, seqNo = " << SequenceNo <<std::endl;
    recRealtime(pQuote, g_quote_fp);
}

void my_callback_t::OnOrderStatistic(MDOrderStatistic * const pQuote, UINT4 SequenceNo){

    if (abs(SequenceNo - StatisticsSequenceNo != 1) && StatisticsSequenceNo != -1) {
        printf("Statistic Sequence break . %d\n", SequenceNo);
    }
    StatisticsSequenceNo = SequenceNo;

//    std::cout << "my_callback_t::OnOrderStatistic, seqNo = " << SequenceNo << std::endl;
    recOrderStatistic(pQuote, g_quote_fp);
}

void my_callback_t::OnMarchPrice(MDMarchPriceQty * const pQuote, UINT4 SequenceNo){

    if (abs(SequenceNo - MarchSequenceNo != 1) && MarchSequenceNo != -1) {
        printf("March Sequence break . %d\n", SequenceNo);
    }
    MarchSequenceNo = SequenceNo;

//    std::cout << "my_callback_t::OnMarchPrice , seqNo = "<< SequenceNo  << std::endl;
    recMarchPrice(pQuote, g_quote_fp);
}

