#include <iostream>
#include <float.h>
#include <string>
#include <map>
#include <stdio.h>
#include <string.h>
#include "DFITCL2Api.h"

using 	namespace std;
using	namespace DFITC_L2;

#define MAX_PURE_DBL          (double)9007199254740991.0
#define MIN_PURE_DBL          (double)-9007199254740991.0
#define MAX_PURE_FLT          (double)16777215
#define MIN_PURE_FLT          (double)-16777215

extern bool IsValidDouble(double lfValue);
extern bool IsValidFloat(double lfValue);

int L2MDBCnt = 0;
int L2TenentrustCnt=0;	
int L2RealtimeCnt=0;	
int L2StatsCnt=0;	
int	L2MarchPCnt=0;	
int	L2ArbiCnt=0;	
int dceL1BDCnt=0;	
int dceL1ArbCnt=0;	




char const BEST_DEEP_QUOTE = '1'; // 嵵飨飩   b
char const ARBI_BEST_QUOTA = '2'; //    e
char const TEN_ENTRUST     = '4'; // λϣǰʮʷֱί   c
char const REAL_TIME_PRICE = '5'; // ʵʱ  h
char const ORDER_STATIST   = '6'; // ίͳ򣬼ȨƽԼί f
char const MARCH_PRICE     = '7'; // ּλɽ  g
char const LST_OPT_PARA    = '8'; // Ȩ


static const double dmax = std::numeric_limits<double>::max();
static const double dmin = std::numeric_limits<double>::min();
static const double fmax = std::numeric_limits<float>::max();
static const double fmin = std::numeric_limits<float>::min();


bool IsValidDouble(double lfValue)
{
    return ((lfValue>dmin) && (lfValue<dmax));
    //return ((lfValue >= MIN_PURE_DBL) && (lfValue <= MAX_PURE_DBL));
}

bool IsValidFloat(double lfValue)
{
    return ((lfValue>fmin) && (lfValue<fmax));
    //return ((lfValue >= MIN_PURE_FLT) && (lfValue <= MAX_PURE_FLT));
}



//L2嵵
void recBestAndDeep(MDBestAndDeep * const pBDQuote, FILE	*fp)
{
    if(pBDQuote==NULL || fp==NULL){
        return;
    }

    char quote[49][100];
    memset(quote,0,sizeof(quote));

    if(pBDQuote->Type!= BEST_DEEP_QUOTE){
        fprintf(fp, "Error Quote Type b\n");
        return;		//
    }
    //CSVļֶ˳
    sprintf(quote[0], "%s", pBDQuote->TradeDate);	//
    sprintf(quote[1], "%s", pBDQuote->Contract);	//Լ
    //--------------------------------------------------------------
    UINT4	TID = 0;				                //.жˣһ
    sprintf(quote[2], "%d", TID);			        //
    sprintf(quote[3], "%s", "ContractName");	    //Լ..ж
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->LastPrice)) {
        sprintf(quote[4], "%.2f", pBDQuote->LastPrice );	//¼
    }
    else {
        sprintf(quote[4], "%s", "nan");	//¼(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->HighPrice)) {
        sprintf(quote[5], "%.2f", pBDQuote->HighPrice);	//߼
    }
    else {
        sprintf(quote[5], "%s", "nan");	//߼(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->LowPrice)) {
        sprintf(quote[6], "%.2f", pBDQuote->LowPrice);	//ͼ
    }
    else {
        sprintf(quote[6], "%s", "nan");	//ͼ(Ƿֵ)
    }
    //--------------------------------------------------------------
    sprintf(quote[7], "%d",   pBDQuote->LastMatchQty); 	//³ɽ
    //--------------------------------------------------------------
    sprintf(quote[8], "%d",   pBDQuote->MatchTotQty); 	//ɽ
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->Turnover)) {
        sprintf(quote[9], "%.2f", pBDQuote->Turnover);	//ɽ
    }
    else {
        sprintf(quote[9], "%s", "nan");	//ɽ(Ƿֵ)
    }
    //--------------------------------------------------------------
    sprintf(quote[10], "%d", pBDQuote->LastOpenInterest); 	//ʼֲ
    sprintf(quote[11], "%d", pBDQuote->OpenInterest); 	//ֲ
    sprintf(quote[12], "%d", pBDQuote->InterestChg); 	//ֲ仯
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->ClearPrice)) {
        sprintf(quote[13], "%.2f", pBDQuote->ClearPrice);	//
    }
    else {
        sprintf(quote[13], "%s", "nan");	//(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->LifeLow)) {
        sprintf(quote[14], "%.2f", pBDQuote->LifeLow);	//ʷͼ
    }
    else {
        sprintf(quote[14], "%s", "nan");	//ʷͼ(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->LifeHigh)) {
        sprintf(quote[15], "%.2f", pBDQuote->LifeHigh);	//ʷ߼
    }
    else {
        sprintf(quote[15], "%s", "nan");	//ʷ߼(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->RiseLimit)) {
        sprintf(quote[16], "%.2f", pBDQuote->RiseLimit);	//ͣ
    }
    else {
        sprintf(quote[16], "%s", "nan");	//ͣ(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->FallLimit)) {
        sprintf(quote[17], "%.2f", pBDQuote->FallLimit);	//ͣ
    }
    else {
        sprintf(quote[17], "%s", "nan");	//ͣ(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->LastClearPrice)) {
        sprintf(quote[18], "%.2f", pBDQuote->LastClearPrice);	//ս
    }
    else {
        sprintf(quote[18], "%s", "nan");	//ս(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->LastClose)) {
        sprintf(quote[19], "%.2f", pBDQuote->LastClose);	//̼
    }
    else {
        sprintf(quote[19], "%s", "nan");	//̼(Ƿֵ)
    }
    //--------------------------------------------------------------

    sprintf(quote[20], "%.2f",0 );		//
    sprintf(quote[21], "%d", 0);		//(ûжӦĳԱ)
    sprintf(quote[22], "%d",0 );		//Ƶ

    sprintf(quote[23], "%.2f", 0);		//		
    sprintf(quote[24], "%d", 0);		//(ûжӦĳԱ)
    sprintf(quote[25], "%d", 0);		//Ƶ				

    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->AvgPrice)) {
        sprintf(quote[26], "%.2f", pBDQuote->AvgPrice);	//վ
    }
    else {
        sprintf(quote[26], "%s", "nan");	//վ(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->AvgPrice)) {
        sprintf(quote[27], "%.2f", pBDQuote->AvgPrice);	//վ
    }
    else {
        sprintf(quote[27], "%s", "nan");	//վ(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->AvgPrice)) {
        sprintf(quote[26], "%.2f", pBDQuote->AvgPrice);	//վ
    }
    else {
        sprintf(quote[26], "%s", "nan");	            //վ(Ƿֵ)
    }
    //--------------------------------------------------------------
    sprintf(quote[27], "%d",pBDQuote->GenTime);	        //ʱ
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->OpenPrice)) {
        sprintf(quote[28], "%.2f", pBDQuote->OpenPrice);//̼
    }
    else {
        sprintf(quote[28], "%s", "nan");	            //̼(Ƿֵ)
    }
    //--------------------------------------------------------------
    if (IsValidFloat(pBDQuote->Close)) {
        sprintf(quote[29], "%.2f", pBDQuote->Close);	//̼
    }
    else {
        sprintf(quote[29], "%s", "nan");	            //̼(Ƿֵ)
    }
    //--------------------------------------------------------------			
    //fprintf(fp, "%c;",pBDQuote->Type);
    fprintf(fp, "%c;",'b');
    for(int i=0;i<29;i++){
	    fprintf(fp, "%s,",quote[i]);
    }
    fprintf(fp, "%s;",quote[29]);

    sprintf(quote[30], "%.2f,%d,%d,%c,", pBDQuote->BuyPriceOne, pBDQuote->BuyQtyOne, pBDQuote->BuyImplyQtyOne ,'1'); // һ/
    sprintf(quote[31], "%.2f,%d,%d,%c,", pBDQuote->BuyPriceTwo, pBDQuote->BuyQtyTwo, pBDQuote->BuyImplyQtyTwo,'1'); // / 
    sprintf(quote[32], "%.2f,%d,%d,%c,", pBDQuote->BuyPriceThree, pBDQuote->BuyQtyThree, pBDQuote->BuyImplyQtyThree,'1'); // /
    sprintf(quote[33], "%.2f,%d,%d,%c,", pBDQuote->BuyPriceFour, pBDQuote->BuyQtyFour, pBDQuote->BuyImplyQtyFour,'1'); // ļ/
    sprintf(quote[34], "%.2f,%d,%d,%c,", pBDQuote->BuyPriceFive, pBDQuote->BuyQtyFive, pBDQuote->BuyImplyQtyFive,'1'); // /

    sprintf(quote[35], "%.2f,%d,%d,%c,", pBDQuote->SellPriceOne, pBDQuote->SellQtyOne, pBDQuote->SellImplyQtyOne,'3'); // һ/
    sprintf(quote[36], "%.2f,%d,%d,%c,", pBDQuote->SellPriceTwo, pBDQuote->SellQtyTwo, pBDQuote->SellImplyQtyTwo,'3'); // / 
    sprintf(quote[37], "%.2f,%d,%d,%c,", pBDQuote->SellPriceThree, pBDQuote->SellQtyThree, pBDQuote->SellImplyQtyThree,'3'); // /
    sprintf(quote[37], "%.2f,%d,%d,%c,", pBDQuote->SellPriceFour, pBDQuote->SellQtyFour, pBDQuote->SellImplyQtyFour,'3'); // ļ/
    sprintf(quote[39], "%.2f,%d,%d,%c,", pBDQuote->SellPriceFive, pBDQuote->SellQtyFive, pBDQuote->SellImplyQtyFive,'3'); // /

    for(int i=30;i<39;i++){
	    fprintf(fp, "%s|",quote[i]);
    }
    fprintf(fp, "%s;",quote[39]);   //һ治߷ָ

    sprintf(quote[40], "%.6f",   IsValidDouble(pBDQuote->Delta) ? pBDQuote->Delta : 0);  //Delta
    sprintf(quote[41], "%.6f",   IsValidDouble(pBDQuote->Gamma) ? pBDQuote->Gamma : 0);  //Gamma
    sprintf(quote[42], "%.6f",   IsValidDouble(pBDQuote->Rho) ? pBDQuote->Rho : 0);  //Rho
    sprintf(quote[43], "%.6f",   IsValidDouble(pBDQuote->Theta) ? pBDQuote->Theta : 0);  //Theta
    sprintf(quote[44], "%.6f",   IsValidDouble(pBDQuote->Vega) ? pBDQuote->Vega : 0);  //Vega

    for(int i=40;i<44;i++){
	    fprintf(fp, "%s,",quote[i]);
    }
    fprintf(fp, "%s;",quote[44]);
    //ʱȱʧ
    fprintf( fp, "%s\n",pBDQuote->GenTime );	//fprintf(fp, "Timestamp\n");
    L2MDBCnt++;
}




//L2ʮί
//λϣǰʮʷֱί
void recTenEntrust(MDTenEntrust * const p_quote,FILE *fp)
{
	if(p_quote==NULL || fp==NULL){
		return;
	}


	if(p_quote->Type!= TEN_ENTRUST ){
		fprintf(fp, "Error Quote Type c\n");
		return;		//
	}

    char quote[30][30];
    memset(quote,0,sizeof(quote));

    if (IsValidFloat(p_quote->BestBuyOrderPrice)) {
        sprintf(quote[0], "%.2f", p_quote->BestBuyOrderPrice ); // 
    }
    else {
        sprintf(quote[0], "%s", "nan"); // 
    }

    sprintf(quote[1],    "%d", p_quote->BestBuyOrderQtyOne);
    sprintf(quote[2],    "%d", p_quote->BestBuyOrderQtyTwo);
    sprintf(quote[3],    "%d", p_quote->BestBuyOrderQtyThree);
    sprintf(quote[4],    "%d", p_quote->BestBuyOrderQtyFour);
    sprintf(quote[5],    "%d", p_quote->BestBuyOrderQtyFive);
    sprintf(quote[6],    "%d", p_quote->BestBuyOrderQtySix);
    sprintf(quote[7],    "%d", p_quote->BestBuyOrderQtySeven);
    sprintf(quote[8],    "%d", p_quote->BestBuyOrderQtyEight);
    sprintf(quote[9],    "%d", p_quote->BestBuyOrderQtyNine);
    sprintf(quote[10],   "%d", p_quote->BestBuyOrderQtyTen);

    if (IsValidFloat(p_quote->BestSellOrderPrice)) {
        sprintf(quote[11], "%.2f", p_quote->BestSellOrderPrice); // 
    }
    else {
        sprintf(quote[11], "%s", "nan"); // 
    }

    sprintf(quote[12],   "%d", p_quote->BestSellOrderQtyOne);
    sprintf(quote[13],   "%d", p_quote->BestSellOrderQtyTwo);
    sprintf(quote[14],   "%d", p_quote->BestSellOrderQtyThree);
    sprintf(quote[15],   "%d", p_quote->BestSellOrderQtyFour);
    sprintf(quote[16],   "%d", p_quote->BestSellOrderQtyFive);
    sprintf(quote[17],   "%d", p_quote->BestSellOrderQtySix);
    sprintf(quote[18],   "%d", p_quote->BestSellOrderQtySeven);
    sprintf(quote[19],   "%d", p_quote->BestSellOrderQtyEight);
    sprintf(quote[20],   "%d", p_quote->BestSellOrderQtyNine);
    sprintf(quote[21],   "%d", p_quote->BestSellOrderQtyTen);
    sprintf(quote[22],   "%s", p_quote->GenTime);

	//fprintf(fp, "%c;",p_quote->Type);	//'c'
	fprintf(fp, "%c;",'c');

	for(int i=0;i<22;i++){
		fprintf(fp, "%s,",quote[i]);
	}
	fprintf(fp, "%s;%s\n",quote[22],quote[22]);
	L2TenentrustCnt++;
}




//L2ʵʱ
void recRealtime(MDRealTimePrice * const p_quote,FILE *fp) 
{
	if(p_quote==NULL){
		return;
	}

	if(fp==NULL){
		return;
	}

	if(p_quote->Type!=REAL_TIME_PRICE){
		fprintf(fp, "Error Quote Type h\n");
		return;		//
	}

	char quote[30][30];
	sprintf(quote[0],  "%s", p_quote->ContractID);      // Լ
	sprintf(quote[1],  "%.2f", p_quote->RealTimePrice); // ʵʱ
	fprintf(fp, "%c;%s,%s\n",'h',quote[0],quote[1]);	    // 'h'
	L2RealtimeCnt++;
}



//L2ίͳ
void recOrderStatistic(MDOrderStatistic * const p_quote,FILE *fp) 
{		
    if(p_quote==NULL){
        return;
    }

    if(fp==NULL){
        return;
    }

    if(p_quote->Type!=ORDER_STATIST ){
        fprintf(fp, "Error Quote Type f\n");
        return;         //
    }

    char quote[30][30];
    sprintf(quote[0],    "%s", p_quote->ContractID);                  // Լ
    sprintf(quote[1],    "%d", p_quote->TotalBuyOrderNum);              // 
    sprintf(quote[2],    "%d", p_quote->TotalSellOrderNum);             // 
    
    if (IsValidDouble(p_quote->WeightedAverageBuyOrderPrice)) {
        sprintf(quote[3], "%.2f", p_quote->WeightedAverageBuyOrderPrice );
    }
    else {
        sprintf(quote[3], "%s", "nan");
    }

    // Ȩƽί۸
    if (IsValidDouble(p_quote->WeightedAverageSellOrderPrice)) {
        sprintf(quote[4], "%.2f", p_quote->WeightedAverageSellOrderPrice );
    }
    else {
        sprintf(quote[4], "%s", "nan");
    }

    // Ȩƽί۸

    //fprintf(fp, "%c;%s,%s,%s,%s;Timestamp\n",p_quote->Type,quote[0],quote[1],quote[2],quote[3]);	//'f'
    fprintf(fp, "%c;%s,%s,%s,%s;Timestamp\n",'f',quote[0],quote[1],quote[2],quote[3]);	            //'f'
    L2StatsCnt++;
}



//------------------------------------
//L2ּ۳ɽ 'g'
//------------------------------------
void recMarchPrice(MDMarchPriceQty * const p_quote,FILE *fp)
{
	if(p_quote==NULL){
		return;
	}

	if(fp==NULL){
		return;
	}

	if(p_quote->Type!=MARCH_PRICE ){
		fprintf(fp, "Error Quote Type f\n");
		return;		//
	}

    char quote[30][100];
    sprintf(quote[0],"%s", p_quote->ContractID);      // Լ
    sprintf(quote[1],"%.2f,%d,%d,%d,%d", p_quote->PriceOne,p_quote->PriceOneBOQty,p_quote->PriceOneBEQty,p_quote->PriceOneSOQty,p_quote->PriceOneSEQty);
    sprintf(quote[2],"%.2f,%d,%d,%d,%d", p_quote->PriceTwo,p_quote->PriceTwoBOQty,p_quote->PriceTwoBEQty,p_quote->PriceTwoSOQty,p_quote->PriceTwoSEQty); 
    sprintf(quote[3],"%.2f,%d,%d,%d,%d", p_quote->PriceThree, p_quote->PriceThreeBOQty, p_quote->PriceThreeBEQty, p_quote->PriceThreeSOQty, p_quote->PriceThreeSEQty); 
    sprintf(quote[4],"%.2f,%d,%d,%d,%d", p_quote->PriceFour,  p_quote->PriceFourBOQty,  p_quote->PriceFourBEQty,  p_quote->PriceFourSOQty,  p_quote->PriceFourSEQty); 
    sprintf(quote[5],"%.2f,%d,%d,%d,%d", p_quote->PriceFive,  p_quote->PriceFiveBOQty,  p_quote->PriceFiveBEQty,  p_quote->PriceFiveSOQty,  p_quote->PriceFiveSEQty); 

	fprintf(fp, "%c;%s,%s,%s,%s,%s,%s;Timestamp\n",'g',quote[0],quote[1],quote[2],quote[3],quote[4],quote[5] );	//'g'
//	fprintf(fp, "%c;%s,%s,%s,%s,%s,%s;Timestamp\n",p_quote->Type,quote[0],quote[1],quote[2],quote[3],quote[4],quote[5] );	//'g'
	L2MarchPCnt++;
}


//L2+嵵
void recArbi(MDBestAndDeep * const pQuote,FILE *fp)
{
    if(fp==NULL ||pQuote==NULL){
            return;
    }

    if(pQuote->Type!=ARBI_BEST_QUOTA){ 	//e
        fprintf(fp, "Error Quote Type e\n");
        return;		//
    }

    char quote[48][30];
    memset(quote,0,sizeof(quote));

    sprintf(quote[0], "%c", 'e');			    //type
    //	sprintf(quote[0], "%c", pQuote->Type);	//type
    sprintf(quote[1], "%s", pQuote->TradeDate);	//
    sprintf(quote[2], "%s", pQuote->Contract);	//Լ
    UINT4	TID = pQuote->Time;			        //.жˣһ
    sprintf(quote[3], "%d", TID);			    //.TimeTID

    if (IsValidFloat(pQuote->LastPrice)) {
        sprintf(quote[4], "%.2f", pQuote->LastPrice);	//¼
    }
    else {
        sprintf(quote[4], "%s", "nan");
    }

    if (IsValidFloat(pQuote->LowPrice)) {
        sprintf(quote[5], "%.2f", pQuote->LowPrice );	//ͼ
    }
    else {
        sprintf(quote[5], "%s", "nan");
    }

    if (IsValidFloat(pQuote->HighPrice)) {
        sprintf(quote[6], "%.2f", pQuote->HighPrice );	//߼
    }
    else {
        sprintf(quote[6], "%s", "nan");
    }

    if (IsValidFloat(pQuote->LifeLow)) {
        sprintf(quote[7], "%.2f", pQuote->LifeLow ); 	// ʷ
    }
    else {
        sprintf(quote[7], "%s", "nan");
    }

    if (IsValidFloat(pQuote->LifeHigh)) {
        sprintf(quote[8], "%.2f", pQuote->LifeHigh ); 	// ʷ
    }
    else {
        sprintf(quote[8], "%s", "nan");
    }

    if (IsValidFloat(pQuote->RiseLimit)) {
        sprintf(quote[9], "%.2f", pQuote->RiseLimit); 			// ͣ
    }
    else {
        sprintf(quote[9], "%s", "nan");
    }

    if (IsValidFloat(pQuote->FallLimit)) {
        sprintf(quote[10], "%.2f", pQuote->FallLimit); 			// ͣ
    }
    else {
        sprintf(quote[10], "%s", "nan");
    }

#if 0
	sprintf(quote[11], "%.2f",0 );		//
	sprintf(quote[12], "%d", 0);		//(ûжӦĳԱ)
	sprintf(quote[13], "%.2f", 0);		//		
	sprintf(quote[14], "%d", 0);		//(ûжӦĳԱ)
#else
	sprintf(quote[11], "%s", "nan");	//
	sprintf(quote[12], "%s", "nan");	//(ûжӦĳԱ)
	sprintf(quote[13], "%s", "nan");	//		
	sprintf(quote[14], "%s", "nan");	//(ûжӦĳԱ)
#endif
    sprintf(quote[15], "%s", pQuote->GenTime);

    sprintf(quote[16], "%.2f,%d,%d,1", pQuote->BuyPriceOne, pQuote->BuyQtyOne, pQuote->BuyImplyQtyOne); 		// һ//Ƶ,־
    sprintf(quote[17], "%.2f,%d,%d,1", pQuote->BuyPriceTwo, pQuote->BuyQtyTwo, pQuote->BuyImplyQtyTwo); 		// //Ƶ,־ 
    sprintf(quote[18], "%.2f,%d,%d,1", pQuote->BuyPriceThree, pQuote->BuyQtyThree, pQuote->BuyImplyQtyThree); 	// //Ƶ,־
    sprintf(quote[19], "%.2f,%d,%d,1", pQuote->BuyPriceFour, pQuote->BuyQtyFour, pQuote->BuyImplyQtyFour); 		// ļ//Ƶ,־
    sprintf(quote[20], "%.2f,%d,%d,1", pQuote->BuyPriceFive, pQuote->BuyQtyFive, pQuote->BuyImplyQtyFive); 		// //Ƶ,־

    sprintf(quote[21], "%.2f,%d,%d,3", pQuote->SellPriceOne, pQuote->SellQtyOne, pQuote->SellImplyQtyOne); 		// һ//Ƶ,־
    sprintf(quote[22], "%.2f,%d,%d,3", pQuote->SellPriceTwo, pQuote->SellQtyTwo, pQuote->SellImplyQtyTwo); 		// //Ƶ,־ 
    sprintf(quote[23], "%.2f,%d,%d,3", pQuote->SellPriceThree, pQuote->SellQtyThree, pQuote->SellImplyQtyThree);// //Ƶ,־
    sprintf(quote[24], "%.2f,%d,%d,3", pQuote->SellPriceFour, pQuote->SellQtyFour, pQuote->SellImplyQtyFour); 	// ļ//Ƶ,־
    sprintf(quote[25], "%.2f,%d,%d,3", pQuote->SellPriceFive, pQuote->SellQtyFive, pQuote->SellImplyQtyFive); 	// //Ƶ,־


    fprintf(fp, "%s;",quote[0]);					
    for(int i=1;i<15;i++)
    {
        fprintf(fp, "%s,",quote[i]);					
    }
    fprintf(fp, "%s;",quote[15]);					
				
    fprintf(fp, "%s,|%s,|%s,|%s,|%s,|%s,|%s,|%s,|%s,|%s,",
                quote[16],quote[17],quote[18],quote[19],quote[20],
                quote[21],quote[22],quote[23],quote[24],quote[25]);

    fprintf(fp, ";%s\n",pQuote->GenTime);      //˴ʱTimestamp
    L2ArbiCnt++;	
}

